#include "testlib.h"
#include <iostream>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    /* Read number from command line. */
    int n = atoi(argv[1]);
    int d = atoi(argv[2]);
    vector<int> a(n), b(n), cnt(n, 0), h(n, 0);
    vector<int> v;
    v.push_back(0);
    for (int i = 1; i < n; i++)
    {
    	int x = v[rnd.next(0, (int)v.size() - 1)];
    	a[i] = x;
    	b[i] = i;
    	cnt[x]++;
    	h[i] = h[x] + 1;
    	if (h[i] < d)
    		v.push_back(i);
    }
    int num = 0;
    for (int i = 0; i < n; i++)
    	if (cnt[i] == 0)
    		num++;
    int k = rnd.next(1, min(num + min(5, (n + 9) / 10), n));
    cout << n << " " << k << "\n";
    for (int i = 1; i < n; i++)
    {
    	if (i > 1)
    		cout << " ";
    	cout << a[i] + 1;
    }
    cout << "\n";
    return 0;    
}