// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
string dir_symb = "^>v<";

int get_dir(char c) {
	for (int i = 0; i < 4; ++i) {
		if (c == dir_symb[i]) {
			return i;
		}
	}
	return -1;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);

	vector<vector<char>> outp(n, vector<char>(n, '.'));

	vector<int> rows(n), columns(n);
	iota(rows.begin(), rows.end(), 0);
	iota(columns.begin(), columns.end(), 0);
	shuffle(rows.begin(), rows.end());
	shuffle(columns.begin(), columns.end());
	rows.resize(k);
	columns.resize(k);

	for (int i = 0; i < k; ++i) {
		outp[rows[i]][columns[i]] = 'O';
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (outp[i][j] != 'O') {
				if (rnd.next(0, 1)) {
					outp[i][j] = '+';
				}
			}
		}
	}


	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << outp[i][j];
		}
		cout << "\n";
	}

	return 0;
}