// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXV = 1'000'000'000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int diff_vals = atoi(argv[2]);
	int ops = atoi(argv[3]);

	set<int> vals;
	while (szof(vals) < diff_vals) {
		vals.insert(rnd.next(1, MAXV));
	}

	vector<int> vals_arr(vals.begin(), vals.end());

	deque<int> arr;
	for (int i = 0; i < n; ++i) {
		arr.push_back(vals_arr[rnd.next(0, diff_vals - 1)]);
	}

	sort(arr.begin(), arr.end());

	vector<int> removed;

	for (int i = 0; i < ops; ++i) {
		if (rnd.next(0, 1)) {
			removed.push_back(arr.front());
			arr.pop_front();
		} else {
			removed.push_back(arr.back());
			arr.pop_back();
		}
	}

	shuffle(removed.begin(), removed.end());

	vector<int> order;
	for (int i = 0; i < szof(arr); ++i) {
		order.push_back(0);
	}
	for (int i = 0; i < szof(removed); ++i) {
		order.push_back(1);
	}

	shuffle(order.begin(), order.end());

	vector<int> outp;
	int cnt0 = 0, cnt1 = 0;
	for (int t : order) {
		if (t == 0) {
			outp.push_back(arr[cnt0]);
			++cnt0;
		} else {
			outp.push_back(removed[cnt1]);
			++cnt1;
		}
	}

	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		cout << outp[i];
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}