#include <bits/stdc++.h>
using namespace std;

struct segment 
{
    int beg, end, len;
};

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    
    auto b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    map<int, int> ind;
    for (int i = 0; i < int(b.size()); i++)
        ind[b[i]] = i;

    vector<pair<int, int>> c;
    for (int i = 0; i < n; i++)
    {
        a[i] = ind[a[i]];
        c.push_back({a[i], i});
    }
    sort(c.begin(), c.end());

    int k = b.size();
    vector<int> first(k, -1);
    vector<int> last(k);
    for (int i = 0; i < n; i++)
    {
        int x = a[i];
        if (first[x] == -1)
            first[x] = i;
        last[x] = i;    
    }
    vector<segment> segs;
    segment curseg;
    curseg.beg = first[0];
    curseg.end = last[0];
    curseg.len = upper_bound(c.begin(), c.end(), make_pair(0, n)) - upper_bound(c.begin(), c.end(), make_pair(0, -1)); 
    for (int i = 1; i < k; i++)
    {
        segment nextseg;
        nextseg.beg = first[i];
        nextseg.end = last[i];
        nextseg.len = upper_bound(c.begin(), c.end(), make_pair(i, n)) - upper_bound(c.begin(), c.end(), make_pair(i, -1)); 

        if (curseg.end < nextseg.beg)
        {
            curseg.end = nextseg.end;
            curseg.len += nextseg.len;
        }
        else
        {
            segs.push_back(curseg);
            //cout << curseg.beg << ' ' << curseg.end << ' ' << curseg.len << endl;
            //cout << a[curseg.beg] << ' ' << a[curseg.end] << endl;
            curseg = nextseg;
        }
    
    }
    segs.push_back(curseg);
    //cout << curseg.beg << ' ' << curseg.end << ' ' << curseg.len << endl;
    //cout << a[curseg.beg] << ' ' << a[curseg.end] << endl;
            
    int maxlen = 0;
    for (int i = 0; i < int(segs.size()); i++)
    {
        int cur = segs[i].len;
        int l = a[segs[i].beg]; 
        int r = a[segs[i].end];
        cur += upper_bound(c.begin(), c.end(), make_pair(l - 1, segs[i].beg)) - upper_bound(c.begin(), c.end(), make_pair(l - 1, -1));
        cur += upper_bound(c.begin(), c.end(), make_pair(r + 1, n)) - upper_bound(c.begin(), c.end(), make_pair(r + 1, segs[i].end));
        maxlen = max(maxlen, cur);
    }

    cout << n - maxlen << endl;
    return 0;
}

















